<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CollectionInfo StructType
 * Meta informations extracted from the WSDL
 * - documentation: Only required for collections
 * @subpackage Structs
 */
class CollectionInfo extends AbstractStructBase
{
    /**
     * The CollectionContact
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\Contact
     */
    public $CollectionContact;
    /**
     * The CollectionAddress
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\Address
     */
    public $CollectionAddress;
    /**
     * The CollectionTime
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\DateTimeRange
     */
    public $CollectionTime;
    /**
     * Constructor method for CollectionInfo
     * @uses CollectionInfo::setCollectionContact()
     * @uses CollectionInfo::setCollectionAddress()
     * @uses CollectionInfo::setCollectionTime()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Contact $collectionContact
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Address $collectionAddress
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\DateTimeRange $collectionTime
     */
    public function __construct(\app\Service\ShipmentHandler\ParcelForce\StructType\Contact $collectionContact = null, \app\Service\ShipmentHandler\ParcelForce\StructType\Address $collectionAddress = null, \app\Service\ShipmentHandler\ParcelForce\StructType\DateTimeRange $collectionTime = null)
    {
        $this
            ->setCollectionContact($collectionContact)
            ->setCollectionAddress($collectionAddress)
            ->setCollectionTime($collectionTime);
    }
    /**
     * Get CollectionContact value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Contact
     */
    public function getCollectionContact()
    {
        return $this->CollectionContact;
    }
    /**
     * Set CollectionContact value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Contact $collectionContact
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CollectionInfo
     */
    public function setCollectionContact(\app\Service\ShipmentHandler\ParcelForce\StructType\Contact $collectionContact = null)
    {
        $this->CollectionContact = $collectionContact;
        return $this;
    }
    /**
     * Get CollectionAddress value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Address
     */
    public function getCollectionAddress()
    {
        return $this->CollectionAddress;
    }
    /**
     * Set CollectionAddress value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Address $collectionAddress
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CollectionInfo
     */
    public function setCollectionAddress(\app\Service\ShipmentHandler\ParcelForce\StructType\Address $collectionAddress = null)
    {
        $this->CollectionAddress = $collectionAddress;
        return $this;
    }
    /**
     * Get CollectionTime value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\DateTimeRange|null
     */
    public function getCollectionTime()
    {
        return $this->CollectionTime;
    }
    /**
     * Set CollectionTime value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\DateTimeRange $collectionTime
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CollectionInfo
     */
    public function setCollectionTime(\app\Service\ShipmentHandler\ParcelForce\StructType\DateTimeRange $collectionTime = null)
    {
        $this->CollectionTime = $collectionTime;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CollectionInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
