<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CompletedManifests StructType
 * @subpackage Structs
 */
class CompletedManifests extends AbstractStructBase
{
    /**
     * The CompletedManifestInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo[]
     */
    public $CompletedManifestInfo;
    /**
     * Constructor method for CompletedManifests
     * @uses CompletedManifests::setCompletedManifestInfo()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo[] $completedManifestInfo
     */
    public function __construct(array $completedManifestInfo = array())
    {
        $this
            ->setCompletedManifestInfo($completedManifestInfo);
    }
    /**
     * Get CompletedManifestInfo value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo[]
     */
    public function getCompletedManifestInfo()
    {
        return $this->CompletedManifestInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setCompletedManifestInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCompletedManifestInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCompletedManifestInfoForArrayConstraintsFromSetCompletedManifestInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $completedManifestsCompletedManifestInfoItem) {
            // validation for constraint: itemType
            if (!$completedManifestsCompletedManifestInfoItem instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo) {
                $invalidValues[] = is_object($completedManifestsCompletedManifestInfoItem) ? get_class($completedManifestsCompletedManifestInfoItem) : sprintf('%s(%s)', gettype($completedManifestsCompletedManifestInfoItem), var_export($completedManifestsCompletedManifestInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CompletedManifestInfo property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CompletedManifestInfo value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo[] $completedManifestInfo
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifests
     */
    public function setCompletedManifestInfo(array $completedManifestInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($completedManifestInfoArrayErrorMessage = self::validateCompletedManifestInfoForArrayConstraintsFromSetCompletedManifestInfo($completedManifestInfo))) {
            throw new \InvalidArgumentException($completedManifestInfoArrayErrorMessage, __LINE__);
        }
        $this->CompletedManifestInfo = $completedManifestInfo;
        return $this;
    }
    /**
     * Add item to CompletedManifestInfo value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo $item
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifests
     */
    public function addToCompletedManifestInfo(\app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo) {
            throw new \InvalidArgumentException(sprintf('The CompletedManifestInfo property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifestInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CompletedManifestInfo[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedManifests
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
