<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CompletedShipments StructType
 * @subpackage Structs
 */
class CompletedShipments extends AbstractStructBase
{
    /**
     * The CompletedShipment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment[]
     */
    public $CompletedShipment;
    /**
     * Constructor method for CompletedShipments
     * @uses CompletedShipments::setCompletedShipment()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment[] $completedShipment
     */
    public function __construct(array $completedShipment = array())
    {
        $this
            ->setCompletedShipment($completedShipment);
    }
    /**
     * Get CompletedShipment value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment[]
     */
    public function getCompletedShipment()
    {
        return $this->CompletedShipment;
    }
    /**
     * This method is responsible for validating the values passed to the setCompletedShipment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCompletedShipment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCompletedShipmentForArrayConstraintsFromSetCompletedShipment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $completedShipmentsCompletedShipmentItem) {
            // validation for constraint: itemType
            if (!$completedShipmentsCompletedShipmentItem instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment) {
                $invalidValues[] = is_object($completedShipmentsCompletedShipmentItem) ? get_class($completedShipmentsCompletedShipmentItem) : sprintf('%s(%s)', gettype($completedShipmentsCompletedShipmentItem), var_export($completedShipmentsCompletedShipmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CompletedShipment property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CompletedShipment value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment[] $completedShipment
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipments
     */
    public function setCompletedShipment(array $completedShipment = array())
    {
        // validation for constraint: array
        if ('' !== ($completedShipmentArrayErrorMessage = self::validateCompletedShipmentForArrayConstraintsFromSetCompletedShipment($completedShipment))) {
            throw new \InvalidArgumentException($completedShipmentArrayErrorMessage, __LINE__);
        }
        $this->CompletedShipment = $completedShipment;
        return $this;
    }
    /**
     * Add item to CompletedShipment value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment $item
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipments
     */
    public function addToCompletedShipment(\app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment) {
            throw new \InvalidArgumentException(sprintf('The CompletedShipment property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CompletedShipment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
