<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContentDetails StructType
 * @subpackage Structs
 */
class ContentDetails extends AbstractStructBase
{
    /**
     * The ContentDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail[]
     */
    public $ContentDetail;
    /**
     * Constructor method for ContentDetails
     * @uses ContentDetails::setContentDetail()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail[] $contentDetail
     */
    public function __construct(array $contentDetail = array())
    {
        $this
            ->setContentDetail($contentDetail);
    }
    /**
     * Get ContentDetail value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail[]
     */
    public function getContentDetail()
    {
        return $this->ContentDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setContentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setContentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateContentDetailForArrayConstraintsFromSetContentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $contentDetailsContentDetailItem) {
            // validation for constraint: itemType
            if (!$contentDetailsContentDetailItem instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail) {
                $invalidValues[] = is_object($contentDetailsContentDetailItem) ? get_class($contentDetailsContentDetailItem) : sprintf('%s(%s)', gettype($contentDetailsContentDetailItem), var_export($contentDetailsContentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ContentDetail property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ContentDetail value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail[] $contentDetail
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetails
     */
    public function setContentDetail(array $contentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($contentDetailArrayErrorMessage = self::validateContentDetailForArrayConstraintsFromSetContentDetail($contentDetail))) {
            throw new \InvalidArgumentException($contentDetailArrayErrorMessage, __LINE__);
        }
        $this->ContentDetail = $contentDetail;
        return $this;
    }
    /**
     * Add item to ContentDetail value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail $item
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetails
     */
    public function addToContentDetail(\app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail) {
            throw new \InvalidArgumentException(sprintf('The ContentDetail property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ContentDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ContentDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
