<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateManifestRequest StructType
 * Meta informations extracted from the WSDL
 * - type: ns:CreateManifestRequest
 * @subpackage Structs
 */
class CreateManifestRequest extends BaseRequest
{
    /**
     * The DepartmentId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $DepartmentId;
    /**
     * Constructor method for CreateManifestRequest
     * @uses CreateManifestRequest::setDepartmentId()
     * @param int $departmentId
     */
    public function __construct($departmentId = null)
    {
        $this
            ->setDepartmentId($departmentId);
    }
    /**
     * Get DepartmentId value
     * @return int|null
     */
    public function getDepartmentId()
    {
        return $this->DepartmentId;
    }
    /**
     * Set DepartmentId value
     * @param int $departmentId
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CreateManifestRequest
     */
    public function setDepartmentId($departmentId = null)
    {
        // validation for constraint: int
        if (!is_null($departmentId) && !(is_int($departmentId) || ctype_digit($departmentId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($departmentId, true), gettype($departmentId)), __LINE__);
        }
        $this->DepartmentId = $departmentId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CreateManifestRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
