<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreatePrintReply StructType
 * Meta informations extracted from the WSDL
 * - type: ns:CreatePrintReply
 * @subpackage Structs
 */
class CreatePrintReply extends BaseReply
{
    /**
     * The CompletedShipmentInfoCreatePrint
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipmentInfoCreatePrint
     */
    public $CompletedShipmentInfoCreatePrint;
    /**
     * The Label
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\Document
     */
    public $Label;
    /**
     * The LabelData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData
     */
    public $LabelData;
    /**
     * The PartnerCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PartnerCode;
    /**
     * Constructor method for CreatePrintReply
     * @uses CreatePrintReply::setCompletedShipmentInfoCreatePrint()
     * @uses CreatePrintReply::setLabel()
     * @uses CreatePrintReply::setLabelData()
     * @uses CreatePrintReply::setPartnerCode()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipmentInfoCreatePrint $completedShipmentInfoCreatePrint
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Document $label
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData
     * @param string $partnerCode
     */
    public function __construct(\app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipmentInfoCreatePrint $completedShipmentInfoCreatePrint = null, \app\Service\ShipmentHandler\ParcelForce\StructType\Document $label = null, \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData = null, $partnerCode = null)
    {
        $this
            ->setCompletedShipmentInfoCreatePrint($completedShipmentInfoCreatePrint)
            ->setLabel($label)
            ->setLabelData($labelData)
            ->setPartnerCode($partnerCode);
    }
    /**
     * Get CompletedShipmentInfoCreatePrint value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipmentInfoCreatePrint|null
     */
    public function getCompletedShipmentInfoCreatePrint()
    {
        return $this->CompletedShipmentInfoCreatePrint;
    }
    /**
     * Set CompletedShipmentInfoCreatePrint value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipmentInfoCreatePrint $completedShipmentInfoCreatePrint
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CreatePrintReply
     */
    public function setCompletedShipmentInfoCreatePrint(\app\Service\ShipmentHandler\ParcelForce\StructType\CompletedShipmentInfoCreatePrint $completedShipmentInfoCreatePrint = null)
    {
        $this->CompletedShipmentInfoCreatePrint = $completedShipmentInfoCreatePrint;
        return $this;
    }
    /**
     * Get Label value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Document|null
     */
    public function getLabel()
    {
        return $this->Label;
    }
    /**
     * Set Label value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Document $label
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CreatePrintReply
     */
    public function setLabel(\app\Service\ShipmentHandler\ParcelForce\StructType\Document $label = null)
    {
        $this->Label = $label;
        return $this;
    }
    /**
     * Get LabelData value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData|null
     */
    public function getLabelData()
    {
        return $this->LabelData;
    }
    /**
     * Set LabelData value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CreatePrintReply
     */
    public function setLabelData(\app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData = null)
    {
        $this->LabelData = $labelData;
        return $this;
    }
    /**
     * Get PartnerCode value
     * @return string|null
     */
    public function getPartnerCode()
    {
        return $this->PartnerCode;
    }
    /**
     * Set PartnerCode value
     * @param string $partnerCode
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CreatePrintReply
     */
    public function setPartnerCode($partnerCode = null)
    {
        // validation for constraint: string
        if (!is_null($partnerCode) && !is_string($partnerCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($partnerCode, true), gettype($partnerCode)), __LINE__);
        }
        $this->PartnerCode = $partnerCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\CreatePrintReply
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
