<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FindRequest StructType
 * Meta informations extracted from the WSDL
 * - type: ns:FindRequest
 * @subpackage Structs
 */
class FindRequest extends BaseRequest
{
    /**
     * The ConvenientCollect
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\ConvenientCollect
     */
    public $ConvenientCollect;
    /**
     * The SpecifiedPostOffice
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\SpecifiedPostOffice
     */
    public $SpecifiedPostOffice;
    /**
     * The PAF
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\PAF
     */
    public $PAF;
    /**
     * The SafePlaces
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $SafePlaces;
    /**
     * The NominatedDeliveryDates
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\NominatedDeliveryDates
     */
    public $NominatedDeliveryDates;
    /**
     * The PostcodeExclusion
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\PostcodeExclusion
     */
    public $PostcodeExclusion;
    /**
     * Constructor method for FindRequest
     * @uses FindRequest::setConvenientCollect()
     * @uses FindRequest::setSpecifiedPostOffice()
     * @uses FindRequest::setPAF()
     * @uses FindRequest::setSafePlaces()
     * @uses FindRequest::setNominatedDeliveryDates()
     * @uses FindRequest::setPostcodeExclusion()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ConvenientCollect $convenientCollect
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\SpecifiedPostOffice $specifiedPostOffice
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\PAF $pAF
     * @param bool $safePlaces
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\NominatedDeliveryDates $nominatedDeliveryDates
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\PostcodeExclusion $postcodeExclusion
     */
    public function __construct(\app\Service\ShipmentHandler\ParcelForce\StructType\ConvenientCollect $convenientCollect = null, \app\Service\ShipmentHandler\ParcelForce\StructType\SpecifiedPostOffice $specifiedPostOffice = null, \app\Service\ShipmentHandler\ParcelForce\StructType\PAF $pAF = null, $safePlaces = null, \app\Service\ShipmentHandler\ParcelForce\StructType\NominatedDeliveryDates $nominatedDeliveryDates = null, \app\Service\ShipmentHandler\ParcelForce\StructType\PostcodeExclusion $postcodeExclusion = null)
    {
        $this
            ->setConvenientCollect($convenientCollect)
            ->setSpecifiedPostOffice($specifiedPostOffice)
            ->setPAF($pAF)
            ->setSafePlaces($safePlaces)
            ->setNominatedDeliveryDates($nominatedDeliveryDates)
            ->setPostcodeExclusion($postcodeExclusion);
    }
    /**
     * Get ConvenientCollect value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ConvenientCollect|null
     */
    public function getConvenientCollect()
    {
        return $this->ConvenientCollect;
    }
    /**
     * Set ConvenientCollect value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ConvenientCollect $convenientCollect
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\FindRequest
     */
    public function setConvenientCollect(\app\Service\ShipmentHandler\ParcelForce\StructType\ConvenientCollect $convenientCollect = null)
    {
        $this->ConvenientCollect = $convenientCollect;
        return $this;
    }
    /**
     * Get SpecifiedPostOffice value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\SpecifiedPostOffice|null
     */
    public function getSpecifiedPostOffice()
    {
        return $this->SpecifiedPostOffice;
    }
    /**
     * Set SpecifiedPostOffice value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\SpecifiedPostOffice $specifiedPostOffice
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\FindRequest
     */
    public function setSpecifiedPostOffice(\app\Service\ShipmentHandler\ParcelForce\StructType\SpecifiedPostOffice $specifiedPostOffice = null)
    {
        $this->SpecifiedPostOffice = $specifiedPostOffice;
        return $this;
    }
    /**
     * Get PAF value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\PAF|null
     */
    public function getPAF()
    {
        return $this->PAF;
    }
    /**
     * Set PAF value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\PAF $pAF
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\FindRequest
     */
    public function setPAF(\app\Service\ShipmentHandler\ParcelForce\StructType\PAF $pAF = null)
    {
        $this->PAF = $pAF;
        return $this;
    }
    /**
     * Get SafePlaces value
     * @return bool|null
     */
    public function getSafePlaces()
    {
        return $this->SafePlaces;
    }
    /**
     * Set SafePlaces value
     * @param bool $safePlaces
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\FindRequest
     */
    public function setSafePlaces($safePlaces = null)
    {
        // validation for constraint: boolean
        if (!is_null($safePlaces) && !is_bool($safePlaces)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($safePlaces, true), gettype($safePlaces)), __LINE__);
        }
        $this->SafePlaces = $safePlaces;
        return $this;
    }
    /**
     * Get NominatedDeliveryDates value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\NominatedDeliveryDates|null
     */
    public function getNominatedDeliveryDates()
    {
        return $this->NominatedDeliveryDates;
    }
    /**
     * Set NominatedDeliveryDates value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\NominatedDeliveryDates $nominatedDeliveryDates
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\FindRequest
     */
    public function setNominatedDeliveryDates(\app\Service\ShipmentHandler\ParcelForce\StructType\NominatedDeliveryDates $nominatedDeliveryDates = null)
    {
        $this->NominatedDeliveryDates = $nominatedDeliveryDates;
        return $this;
    }
    /**
     * Get PostcodeExclusion value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\PostcodeExclusion|null
     */
    public function getPostcodeExclusion()
    {
        return $this->PostcodeExclusion;
    }
    /**
     * Set PostcodeExclusion value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\PostcodeExclusion $postcodeExclusion
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\FindRequest
     */
    public function setPostcodeExclusion(\app\Service\ShipmentHandler\ParcelForce\StructType\PostcodeExclusion $postcodeExclusion = null)
    {
        $this->PostcodeExclusion = $postcodeExclusion;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\FindRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
