<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HazardousGoods StructType
 * @subpackage Structs
 */
class HazardousGoods extends AbstractStructBase
{
    /**
     * The HazardousGood
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood[]
     */
    public $HazardousGood;
    /**
     * Constructor method for HazardousGoods
     * @uses HazardousGoods::setHazardousGood()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood[] $hazardousGood
     */
    public function __construct(array $hazardousGood = array())
    {
        $this
            ->setHazardousGood($hazardousGood);
    }
    /**
     * Get HazardousGood value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood[]
     */
    public function getHazardousGood()
    {
        return $this->HazardousGood;
    }
    /**
     * This method is responsible for validating the values passed to the setHazardousGood method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHazardousGood method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHazardousGoodForArrayConstraintsFromSetHazardousGood(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $hazardousGoodsHazardousGoodItem) {
            // validation for constraint: itemType
            if (!$hazardousGoodsHazardousGoodItem instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood) {
                $invalidValues[] = is_object($hazardousGoodsHazardousGoodItem) ? get_class($hazardousGoodsHazardousGoodItem) : sprintf('%s(%s)', gettype($hazardousGoodsHazardousGoodItem), var_export($hazardousGoodsHazardousGoodItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HazardousGood property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HazardousGood value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood[] $hazardousGood
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGoods
     */
    public function setHazardousGood(array $hazardousGood = array())
    {
        // validation for constraint: array
        if ('' !== ($hazardousGoodArrayErrorMessage = self::validateHazardousGoodForArrayConstraintsFromSetHazardousGood($hazardousGood))) {
            throw new \InvalidArgumentException($hazardousGoodArrayErrorMessage, __LINE__);
        }
        $this->HazardousGood = $hazardousGood;
        return $this;
    }
    /**
     * Add item to HazardousGood value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood $item
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGoods
     */
    public function addToHazardousGood(\app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood) {
            throw new \InvalidArgumentException(sprintf('The HazardousGood property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGood, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HazardousGood[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\HazardousGoods
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
