<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Hours StructType
 * @subpackage Structs
 */
class Hours extends AbstractStructBase
{
    /**
     * The Open
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Open;
    /**
     * The Close
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Close;
    /**
     * The CloseLunch
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $CloseLunch;
    /**
     * The AfterLunchOpening
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AfterLunchOpening;
    /**
     * Constructor method for Hours
     * @uses Hours::setOpen()
     * @uses Hours::setClose()
     * @uses Hours::setCloseLunch()
     * @uses Hours::setAfterLunchOpening()
     * @param string $open
     * @param string $close
     * @param string $closeLunch
     * @param string $afterLunchOpening
     */
    public function __construct($open = null, $close = null, $closeLunch = null, $afterLunchOpening = null)
    {
        $this
            ->setOpen($open)
            ->setClose($close)
            ->setCloseLunch($closeLunch)
            ->setAfterLunchOpening($afterLunchOpening);
    }
    /**
     * Get Open value
     * @return string|null
     */
    public function getOpen()
    {
        return $this->Open;
    }
    /**
     * Set Open value
     * @param string $open
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Hours
     */
    public function setOpen($open = null)
    {
        // validation for constraint: string
        if (!is_null($open) && !is_string($open)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($open, true), gettype($open)), __LINE__);
        }
        $this->Open = $open;
        return $this;
    }
    /**
     * Get Close value
     * @return string|null
     */
    public function getClose()
    {
        return $this->Close;
    }
    /**
     * Set Close value
     * @param string $close
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Hours
     */
    public function setClose($close = null)
    {
        // validation for constraint: string
        if (!is_null($close) && !is_string($close)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($close, true), gettype($close)), __LINE__);
        }
        $this->Close = $close;
        return $this;
    }
    /**
     * Get CloseLunch value
     * @return string|null
     */
    public function getCloseLunch()
    {
        return $this->CloseLunch;
    }
    /**
     * Set CloseLunch value
     * @param string $closeLunch
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Hours
     */
    public function setCloseLunch($closeLunch = null)
    {
        // validation for constraint: string
        if (!is_null($closeLunch) && !is_string($closeLunch)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($closeLunch, true), gettype($closeLunch)), __LINE__);
        }
        $this->CloseLunch = $closeLunch;
        return $this;
    }
    /**
     * Get AfterLunchOpening value
     * @return string|null
     */
    public function getAfterLunchOpening()
    {
        return $this->AfterLunchOpening;
    }
    /**
     * Set AfterLunchOpening value
     * @param string $afterLunchOpening
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Hours
     */
    public function setAfterLunchOpening($afterLunchOpening = null)
    {
        // validation for constraint: string
        if (!is_null($afterLunchOpening) && !is_string($afterLunchOpening)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($afterLunchOpening, true), gettype($afterLunchOpening)), __LINE__);
        }
        $this->AfterLunchOpening = $afterLunchOpening;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Hours
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
