<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Images StructType
 * @subpackage Structs
 */
class Images extends AbstractStructBase
{
    /**
     * The Image
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\Image[]
     */
    public $Image;
    /**
     * Constructor method for Images
     * @uses Images::setImage()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Image[] $image
     */
    public function __construct(array $image = array())
    {
        $this
            ->setImage($image);
    }
    /**
     * Get Image value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Image[]|null
     */
    public function getImage()
    {
        return $this->Image;
    }
    /**
     * This method is responsible for validating the values passed to the setImage method
     * This method is willingly generated in order to preserve the one-line inline validation within the setImage method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateImageForArrayConstraintsFromSetImage(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $imagesImageItem) {
            // validation for constraint: itemType
            if (!$imagesImageItem instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\Image) {
                $invalidValues[] = is_object($imagesImageItem) ? get_class($imagesImageItem) : sprintf('%s(%s)', gettype($imagesImageItem), var_export($imagesImageItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Image property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\Image, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Image value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Image[] $image
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Images
     */
    public function setImage(array $image = array())
    {
        // validation for constraint: array
        if ('' !== ($imageArrayErrorMessage = self::validateImageForArrayConstraintsFromSetImage($image))) {
            throw new \InvalidArgumentException($imageArrayErrorMessage, __LINE__);
        }
        $this->Image = $image;
        return $this;
    }
    /**
     * Add item to Image value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Image $item
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Images
     */
    public function addToImage(\app\Service\ShipmentHandler\ParcelForce\StructType\Image $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\Image) {
            throw new \InvalidArgumentException(sprintf('The Image property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\Image, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Image[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Images
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
