<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ManifestShipments StructType
 * @subpackage Structs
 */
class ManifestShipments extends AbstractStructBase
{
    /**
     * The ManifestShipment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment[]
     */
    public $ManifestShipment;
    /**
     * Constructor method for ManifestShipments
     * @uses ManifestShipments::setManifestShipment()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment[] $manifestShipment
     */
    public function __construct(array $manifestShipment = array())
    {
        $this
            ->setManifestShipment($manifestShipment);
    }
    /**
     * Get ManifestShipment value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment[]
     */
    public function getManifestShipment()
    {
        return $this->ManifestShipment;
    }
    /**
     * This method is responsible for validating the values passed to the setManifestShipment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManifestShipment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManifestShipmentForArrayConstraintsFromSetManifestShipment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manifestShipmentsManifestShipmentItem) {
            // validation for constraint: itemType
            if (!$manifestShipmentsManifestShipmentItem instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment) {
                $invalidValues[] = is_object($manifestShipmentsManifestShipmentItem) ? get_class($manifestShipmentsManifestShipmentItem) : sprintf('%s(%s)', gettype($manifestShipmentsManifestShipmentItem), var_export($manifestShipmentsManifestShipmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ManifestShipment property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ManifestShipment value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment[] $manifestShipment
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipments
     */
    public function setManifestShipment(array $manifestShipment = array())
    {
        // validation for constraint: array
        if ('' !== ($manifestShipmentArrayErrorMessage = self::validateManifestShipmentForArrayConstraintsFromSetManifestShipment($manifestShipment))) {
            throw new \InvalidArgumentException($manifestShipmentArrayErrorMessage, __LINE__);
        }
        $this->ManifestShipment = $manifestShipment;
        return $this;
    }
    /**
     * Add item to ManifestShipment value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment $item
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipments
     */
    public function addToManifestShipment(\app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment) {
            throw new \InvalidArgumentException(sprintf('The ManifestShipment property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ManifestShipment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ManifestShipments
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
