<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Parcels StructType
 * @subpackage Structs
 */
class Parcels extends AbstractStructBase
{
    /**
     * The Parcel
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel[]
     */
    public $Parcel;
    /**
     * Constructor method for Parcels
     * @uses Parcels::setParcel()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel[] $parcel
     */
    public function __construct(array $parcel = array())
    {
        $this
            ->setParcel($parcel);
    }
    /**
     * Get Parcel value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel[]
     */
    public function getParcel()
    {
        return $this->Parcel;
    }
    /**
     * This method is responsible for validating the values passed to the setParcel method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParcel method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParcelForArrayConstraintsFromSetParcel(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $parcelsParcelItem) {
            // validation for constraint: itemType
            if (!$parcelsParcelItem instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel) {
                $invalidValues[] = is_object($parcelsParcelItem) ? get_class($parcelsParcelItem) : sprintf('%s(%s)', gettype($parcelsParcelItem), var_export($parcelsParcelItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Parcel property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Parcel value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel[] $parcel
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Parcels
     */
    public function setParcel(array $parcel = array())
    {
        // validation for constraint: array
        if ('' !== ($parcelArrayErrorMessage = self::validateParcelForArrayConstraintsFromSetParcel($parcel))) {
            throw new \InvalidArgumentException($parcelArrayErrorMessage, __LINE__);
        }
        $this->Parcel = $parcel;
        return $this;
    }
    /**
     * Add item to Parcel value
     * @throws \InvalidArgumentException
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel $item
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Parcels
     */
    public function addToParcel(\app\Service\ShipmentHandler\ParcelForce\StructType\Parcel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel) {
            throw new \InvalidArgumentException(sprintf('The Parcel property can only contain items of type \app\Service\ShipmentHandler\ParcelForce\StructType\Parcel, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Parcel[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Parcels
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
