<?php

namespace app\Service\ShipmentHandler\ParcelForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrintDocumentReply StructType
 * Meta informations extracted from the WSDL
 * - type: ns:PrintDocumentReply
 * @subpackage Structs
 */
class PrintDocumentReply extends BaseReply
{
    /**
     * The Label
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\Document
     */
    public $Label;
    /**
     * The LabelData
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData
     */
    public $LabelData;
    /**
     * The DocumentType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \app\Service\ShipmentHandler\ParcelForce\StructType\Document
     */
    public $DocumentType;
    /**
     * Constructor method for PrintDocumentReply
     * @uses PrintDocumentReply::setLabel()
     * @uses PrintDocumentReply::setLabelData()
     * @uses PrintDocumentReply::setDocumentType()
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Document $label
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Document $documentType
     */
    public function __construct(\app\Service\ShipmentHandler\ParcelForce\StructType\Document $label = null, \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData = null, \app\Service\ShipmentHandler\ParcelForce\StructType\Document $documentType = null)
    {
        $this
            ->setLabel($label)
            ->setLabelData($labelData)
            ->setDocumentType($documentType);
    }
    /**
     * Get Label value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Document|null
     */
    public function getLabel()
    {
        return $this->Label;
    }
    /**
     * Set Label value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Document $label
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\PrintDocumentReply
     */
    public function setLabel(\app\Service\ShipmentHandler\ParcelForce\StructType\Document $label = null)
    {
        $this->Label = $label;
        return $this;
    }
    /**
     * Get LabelData value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData|null
     */
    public function getLabelData()
    {
        return $this->LabelData;
    }
    /**
     * Set LabelData value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\PrintDocumentReply
     */
    public function setLabelData(\app\Service\ShipmentHandler\ParcelForce\StructType\ShipmentLabelData $labelData = null)
    {
        $this->LabelData = $labelData;
        return $this;
    }
    /**
     * Get DocumentType value
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\Document|null
     */
    public function getDocumentType()
    {
        return $this->DocumentType;
    }
    /**
     * Set DocumentType value
     * @param \app\Service\ShipmentHandler\ParcelForce\StructType\Document $documentType
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\PrintDocumentReply
     */
    public function setDocumentType(\app\Service\ShipmentHandler\ParcelForce\StructType\Document $documentType = null)
    {
        $this->DocumentType = $documentType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \app\Service\ShipmentHandler\ParcelForce\StructType\PrintDocumentReply
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
